write_info:   ; display unique edges, vertices, faces count info.
    push ebp
    mov  ebp,esp
    sub  esp,100

    .str_ed   equ  [ebp-100]
;    .str_vert equ  [ebp-100]

    xor    eax,eax          ; clear draw buffer
    mov    edi,info_screen
    mov    ecx,INFOX * INFOY
    call   fill_aligned
    mov    eax,5 shl 16 + 2
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,uniq_ed
    mov    edi,info_screen
    call   write_text
; unsigned dword integer to ascii procedure
;     in   eax - variable
;          esi - Pointer to ascii string
;   out    esi - desired ascii string
;          edi - end of ascii string  - ptr to memory

    mov    eax,[edges_count]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

;   eax - x * 65536 + y -> where to display
;   ebx - pointer to character table
;   ecx - size x * 65536 + size y -> size of scr buffer
;   esi - pointer to ASCIIZ string to display
;   edi - pointer to scr buffer
    mov    eax,5 shl 16 + 19
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text


    mov    eax,5 shl 16 + 36
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,faces
    mov    edi,info_screen
    call   write_text

    mov    eax,[triangles_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 17
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text

    mov    eax,5 shl 16 + 36 + 34
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,vertices
    mov    edi,info_screen
    call   write_text

    mov    eax,[points_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 87
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text





    movzx  eax,[xres_var]
    invoke StretchDIBits,[hdc],eax,MYRES,INFOX,INFOY,0,0,INFOX,INFOY,info_screen,Ibmi,0,SRCCOPY

    mov  esp,ebp
    pop  ebp
ret




normalize_plane_equation:
 movups xmm0,[plane_equation]    ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps  xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps  xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret
fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov  ebx,ecx
    and  ebx,1111b  ;
    jz   .fill_sse
  @@:
    mov  [edi],eax
    add  edi,4
    sub  ebx,1
    jnz  @b
  .fill_sse:
    shr    ecx,4
    or     ecx,ecx
    jz     .end
    movd   xmm0,eax
    shufps xmm0,xmm0,0
    movaps xmm1,xmm0
    movaps xmm2,xmm0
    movaps xmm3,xmm0
    and    edi,-16 ; to be sure
  @@:
    movaps  [edi],xmm0
    movaps  [edi+16],xmm1
    movaps  [edi+32],xmm2
    movaps  [edi+48],xmm3
    add     edi,64
    sub     ecx,1
    jnz     @b
  .end:
ret
norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     sub     ecx,1
     jnz     @b
ret